#    Amazing Text Fun Game Engine - a engine for the decoding and play of .atf game files
#    Copyright (C) <2002>  <Kenneth Bromberg, Antoni Chan>
#    See README for full license information

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	Questions or comments?  Contact the author - atfengine@alltooflat.com




# ton's utilities for kennyb!

$ABC_FS_DEFAULTSIZE = 75;

# Format a string for screen output.
# will break into chunks no greater than size
# if size is not provided, will use ABC_FS_DEFAULTSIZE
sub FormatString(str, size) {
	my $str = $_[0];
	my $size = $_[1];
	if ($size eq "") {
		$size = $ABC_FS_DEFAULTSIZE;
	}

	my $outstr = " ";
#	for (my $i=0; $i<$size; $i++) {
#		$outstr .= "x";
#	}
#	$outstr .= "\n";

	my $ptr1;
	my $count = 0;
	my $addon;

	while ($str ne "") {
		# find the next space, or end of string
		$ptr1 = index($str, ' ');
		if ( $ptr1 < 0 ) {
			$ptr1 = length($str);
			$addon = $str;
			$str = "";
		} elsif ( $ptr1 == 0 ) {
			# handle beginning spaces
			$ptr2 = 1;
			while ( substr($str,$ptr2,1) eq " " ) {
				$ptr2++;
			}
			$ptr1 = $ptr2;
			$addon = substr($str,0,$ptr1);
			$str = substr($str,$ptr1);
		} else {
			# clip the word
			$addon = substr($str,0,$ptr1);
			$str = substr($str,$ptr1);
		}

		# will it fit?
		if ($count + $ptr1 <= $size) {
			$outstr .= $addon;
			$count += $ptr1 ;

		# won't fit and word is small
		} else {
			if (substr($addon,0,1) eq " ") {		
				$addon = "";
				$ptr1 = 0;
			}
			$outstr .= "\n " . $addon;
			$count = $ptr1;			
		}
	}

    return $outstr;
}

sub kenprint
{
	$outstring = shift;
	$NumLinesToPrint = 20;

	@StringsOut = split(/\n/, $outstring);
	
	foreach $line (@StringsOut) 
	{
		print $line, "\n";
		$numlinesprinted++;
		if ($numlinesprinted == $NumLinesToPrint) 
		{
			$numlinesprinted = 0;
			print "\nHit <ENTER> to continue reading\n";
			<STDIN>
		}
	}
}
1;